#ifndef _VTTY_DB_H_
#define	_VTTY_DB_H_

#include <gdbm.h>

#define	MAXLEN_TTYSUFFIX	128
#define	MAXLEN_IP			16

#define MAX_DB_ENTRY 256

#define VTTY_DB_PATH "/var/vtty/"

enum {
	B75=75,
	B150=150,
	B200=200,
	B300=300,
	B600=600,
	B1200=1200,
	B1800=1800,
	B2400=2400,
	B4800=4800,
	B9600=9600,
	B19200=19200,
	B38400=38400,
	B57600=57600,
	B115200=115200,
	B230400=230400
};

enum {
	DB8=1,
	DB7=2,
	DB6=3,
	DB5=4
};

enum {
	PARITY_NO=1,
	PARITY_EVEN=2,
	PARITY_ODD=3
};

enum {
	FC_NOHW=1,
	FC_HW=2,
	FC_NOSW=3,
	FC_SW=4
};

enum {
	STATUS_DISABLED=0,
	STATUS_ENABLED=1
};

struct _vtty_uart_type_t
{
	unsigned long baudrate;					// baudrate
	int		databits;						// databits
	int		parity;							// parity
	int		flowctrl;						// flow control
};

struct _vtty_db_type_t
{
	int		benable;		// enabled or disabled
	char	ttysuffix[MAXLEN_TTYSUFFIX];	// tty suffix
	int		minor;			// device minor number
	char	target_ip[MAXLEN_IP];		// target ip address
	int		target_port;		// target port
	struct _vtty_uart_type_t uart;		// uart type
} ALIGNOPTION;

int vtty_db_ropen(void);
int vtty_db_wopen(void);
int vtty_db_wopen_new(void);

void vtty_db_close();
int vtty_db_write(void *p);
int vtty_db_get(char *ttysuffix, void *p);
int vtty_db_exists(char *ttysuffix);
int vtty_db_delete(char *ttysuffix);
int vtty_db_get_next(void *prevp, void *p);
int vtty_db_count();
int vtty_db_get_available_minor();
int vtty_db_get_next_by_minornum(int minor, struct _vtty_db_type_t *data);

#endif // _VTTY_DB_H_
